package arm;

import iron.math.Vec4;
//import iron.math.Quat;
//import iron.math.Mat4;
import iron.system.Input;
//import iron.object.Object;
import armory.trait.physics.bullet.RigidBody;
//import armory.trait.physics.PhysicsWorld;
//import armory.trait.internal.CameraController;

class MoveTest extends iron.Trait {
	public function new() {
		super();

		var velocidade = 1.0;
		var direccao = new Vec4();
		var body:RigidBody;

		notifyOnInit(function() {
			body = object.getTrait(RigidBody);
		});

		notifyOnUpdate(function(){
			direccao.set(0, 0, 0);
			if( iron.system.Input.getKeyboard().down("right") || iron.system.Input.getKeyboard().down("d") ){
				  trace("direita");
				  /*object.transform.loc.addf(1 * 0.01,0,0);
        		  object.transform.buildMatrix();*/
				  direccao.add(object.transform.look());
			}else if( iron.system.Input.getKeyboard().down("left") || iron.system.Input.getKeyboard().down("a") ){
				  trace("esquerda");
				  /*object.transform.loc.addf(-1 * 0.01,0,0);
        		  object.transform.buildMatrix();	*/
				  direccao.add(object.transform.look().mult(-1));
			}else if( iron.system.Input.getKeyboard().down("up") || iron.system.Input.getKeyboard().down("w") || iron.system.Input.getKeyboard().down("space") ){

				trace("saltar");
				var bglv = body.getLinearVelocity();
				var velZ = bglv.z;

				/*trace(velZ);
				if(velZ <= 5.0){
					body.applyImpulse(new Vec4(0, 0, 5));
				}*/

				
				var rbs = body.physics.getContacts(body);
				if (rbs != null){
					trace("tem colisoes");
					body.applyImpulse(new Vec4(0, 0, 10));
				}
				
					   

			}
			var btvec = body.getLinearVelocity();
			body.setLinearVelocity(0.0, 0.0, btvec.z - 1.0);
			direccao.mult(velocidade * 5);
			body.activate();
			body.setLinearVelocity(direccao.x, direccao.y, btvec.z - 1.0);
         });
	}
}
